// Jonas Petraška PS 1gr, 2 pogr.

// Trečia užduotis, 13 variantas.

// Parašyti funkciją, kuri iš duoto teksto išmeta žodžius, vienodai skaitomus iš pradžios ir iš galo (tarpų skaičius turi likti nepakitęs).

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <ctype.h>

#define LENGTH 256

//--------------------------------------Function headers-------------------------------------------------------------------------//

void RemovePalindromes( char Line[ ], int Length, char *Line_RW, int *LengthRW );
bool CheckPalindrome( char Word[ ], int Length );

//--------------------------------------------------------------------------------------------------------------------------------//

int main( ){

    FILE *In,
         *Out;

    char Input[ LENGTH ],
         Output[ LENGTH ];

    printf( "Iveskite duomenu failo pavadinima : " );
    scanf( "%s", &Input );

    In = fopen( Input, "r" );

    if( In == NULL ){

        printf( "Nurodytas duomenu failas neegzistuoja. \n" );
        return -1;

    }

    printf( "Iveskite rezultatu failo pavadinima : " );
    scanf( "%s", &Output );

    Out = fopen( Output, "w" );

    if( Out == NULL ){

        printf( "Nurodytas duomenu failas neegzistuoja. \n" );
        return -1;

    }

    char Line[ LENGTH ],
         *Line_RW = NULL;

    Line_RW = ( char* ) malloc( LENGTH * sizeof( char ) );

    int Line_Length,
        RWLine_Length;

    while( fgets( Line, LENGTH, In ) != NULL ){

        RWLine_Length = 0;

        Line[ strcspn( Line, "\n" ) ] = 0;
        Line_Length = strlen( Line ) + 1;

        RemovePalindromes( Line, Line_Length, Line_RW, &RWLine_Length );

        if( RWLine_Length > 0 ){

            Line_RW = ( char* ) realloc( Line_RW, RWLine_Length * sizeof( char ) );
            fwrite( Line_RW,  sizeof( char ), RWLine_Length, Out );

        }

        fprintf( Out, "\n" );

    }

    free( Line_RW );
    fclose( In );
    fclose( Out );

    return 0;

}

//--------------------------------------Function implementations-----------------------------------------------------------------//

void RemovePalindromes( char Line[ ], int Length, char *Line_RW, int *LengthRW ){

    char temp_word[ Length ],
         space = 32;

    int temp_length = 0;

    for( int i = 0; i < Length; i++ ){

        if( isspace( Line[ i ] )  || i == Length - 1  ){

            if( !CheckPalindrome( temp_word, temp_length ) ){

                for( int j = 0; j < temp_length; j++, ( *LengthRW )++ )
                    Line_RW[ *LengthRW ] = temp_word[ j ];

            }

            if( isspace( Line[ i ] ) ){

                Line_RW[ *LengthRW ] = space;
                ( *LengthRW )++;

            }

            memset( temp_word, 0, temp_length );
            temp_length = 0;


        }else{

            temp_word[ temp_length ] = Line[ i ];
            temp_length++;

        }
    }
}

bool CheckPalindrome( char Word[ ], int Length ){

    if( Length == 1 ) return true;

    for( int i = Length - 1, j = 0; j < Length; j++, i-- )
        if( tolower( Word[ i ] ) != tolower( Word[ j ] ) ) return false;

    return true;

}

//--------------------------------------------------------------------------------------------------------------------------------//
